// TODO: add JSON BLOB support
export const customTypes = {
  JSON: 'TEXT'
};

// Defining a type for column configurations

/**
 *  id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, name TEXT, age INTEGER
 */
export function createTableColumns(columnMapping) {
  return Object.entries(columnMapping).map(_ref => {
    let [columnName, column] = _ref;
    const {
      type,
      not_null,
      primary_key,
      unique,
      default: defaultValue
    } = column;
    const typeString = customTypes[type] || type;
    const constraints = [];
    if (not_null) constraints.push('NOT NULL');
    if (primary_key) constraints.push('PRIMARY KEY AUTOINCREMENT');
    if (unique) constraints.push('UNIQUE');
    const defaultValueString = defaultValue ? `DEFAULT ${defaultValue()}` : '';
    return `${columnName} ${typeString} ${constraints.join(' ')} ${defaultValueString}`.trim();
  }).join(', ');
}
//# sourceMappingURL=ColumnType.js.map